



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>LeetCode 88. Merge Sorted Array（合并有序数组）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">LeetCode 88. Merge Sorted Array（合并有序数组）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-02 09:09:06 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>Given two sorted integer arrays&nbsp;<em>nums1</em>&nbsp;and&nbsp;<em>nums2</em>, merge&nbsp;<em>nums2</em>&nbsp;into&nbsp;<em>nums1</em>&nbsp;as one sorted array.</p>
<p>Note:<br />You may assume that&nbsp;<em>nums1</em>&nbsp;has enough space (size that is greater or equal to&nbsp;<em>m</em>&nbsp;+&nbsp;<em>n</em>) to hold additional elements from&nbsp;<em>nums2</em>. The number of elements initialized in&nbsp;<em>nums1</em>&nbsp;and&nbsp;<em>nums2</em>&nbsp;are&nbsp;<em>m</em>&nbsp;and&nbsp;<em>n</em>&nbsp;respectively.</p>
<hr />
<p>题目标签：Array</p>
<p>　　题目给了我们两个有序数组，让我们merge sort，而且nums1 有足够的空间让我们存放 两个array。既然是要放到nums1里，那么我们如果比较nums1 和nums2 的数字，如果是nums2 的数字小的话，就要把nums2 的数字存放进nums1，我们还要另外存放nums1的数字，这样就需要额外space了。所以，我们可以从nums1的end 开始遍历回start， 然后设两个pointers 分别指向 两个array的最后一个数字，这样可以比完大小后直接存放进nums1。注意最后还需要检查一下，nums2是否还有剩下的数字，有的话都需要存进nums1。</p>
<p>Java Solution:</p>
<p>Runtime beats 38.77%</p>
<p>完成日期：04/05/2017</p>
<p>关键词：Array</p>
<p>关键点：Merge sort；Two Pointers；从end遍历回start</p>
<div>
<pre class="prettyprint linenums"> public class Solution<br />
 {<br />
     public void merge(int[] nums1, int m, int[] nums2, int n)<br />
     {<br />
         /* if m = 0, meaning nums1's elements are all done. Need one more while loop after this<br />
            to take care of left elements of nums2.<br />
            if n = 0, meaning nums2's elements are done, the rest of nums1's elements are in the<br />
            right place. No need to take care of them.<br />
         */<br />
         while(m &gt; 0 &amp;&amp; n &gt;0)<br />
         {<br />
             if(nums1[m-1] &gt; nums2[n-1]) // if number 1 &gt; number 2<br />
             {<br />
                 // save nums1's element into nums1's last "empty" spot.<br />
                 nums1[m+n-1] = nums1[m-1];<br />
                 m--;<br />
             }<br />
             else // if number 1 &lt;= number 2<br />
             {<br />
                 // save nums2's element into nums1's last "empty" spot<br />
                 nums1[m+n-1] = nums2[n-1];<br />
                 n--;<br />
             }<br />
         }

         // check if nums2's elements are not finished.<br />
         while(n &gt; 0)<br />
         {<br />
             // save nums2's rest elements into nums1<br />
             nums1[m+n-1] = nums2[n-1];<br />
             n--;<br />
         }<br />
     }<br />
 }</pre>
</div>
<p>参考资料：</p>
<p>http://www.cnblogs.com/springfor/p/3872640.html</p>
<p>LeetCode 算法题目列表 -&nbsp;<a href="http://www.cnblogs.com/jimmycheng/p/7119334.html" rel="external nofollow noreferrer">LeetCode Algorithms Questions List</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq4yl50q.html">Sharp Memory LCD &lpar;ls013b7dh03&rpar;驱动</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv750yq.html">spring&period;net （2）环境搭建 对（1）例子的解释和扩充</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96xd1j9.html">Vs2012 中使用itoa</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zmmj09.html">mysql 查看是否存在某一张表</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdeey3v9.html">10个必备的移动UI设计资源站（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1mw6z9.html">spark-submit工具参数说明</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn12kmg8.html">HTTP中缓存相关</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zlxo09.html">NSDictionary 初始化</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w3v13q.html">C&plus;&plus;获取系统的Mac地址</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1rynk9.html">hbase 使用备忘</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okw6lp9.html">dump datafile block</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydn4z2q.html">&lbrack;MySQL5&period;6&rsqb; 一个简单的optimizer&lowbar;trace示例</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1zw079.html">解决IE6不支持position&colon;fixed&semi;的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdppojvq.html">Vim配置说明</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojj6r5q.html">CentOS7 安装kubernetes</a>
		</li>
						<li><a href="https://www.batexi.com/a/950j2zm8.html">Hibernate基础学习&lpar;二&rpar;&amp;mdash&semi;Hibernate相关API介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1gndmq.html">41&period; leetcode 53&period; Maximum Subarray</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m1wn48.html">浏览器history操作实现一些功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpxr159.html">hbase 性能优化 （转载）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25xkmxq.html">HDU 2006 求奇数的乘积</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8oj3pn1q.html">python基础之元组，集合</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zo6p11q.html">SAP中常用SM系列事务代码总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpg1g7q.html">Exception in thread &quot;main&quot; org&period;hibernate&period;MappingException&colon; You may only specify a cache for root</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljwd3k9.html">如何延长IntelliJ IDEA的试用期？</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jge7v8.html">JavaScript配合button&period;onclick&lpar;&rpar;使用总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rg6lz48.html">System&period;getProperty&lpar;&rpar;参数大全</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjgex28.html">Python循环列表删除元素问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1jm0xq.html">Download the Hibernate Tools</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gezvl78.html">匹配替换第n个字符串</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7z24x19.html">C&num;进阶之AOP</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
